		#  UNMASM
		#  / Ha3sm / reference / Forthy / colorForth
		#  BOOT.ASM
		#  Sat Aug 23 11:19:16 2003

		#  Floppy boot segment


H=0#actually  7c00
L  start
	jump start0
	nop


	ascii " $(( cmcf 1.0 )) "
	ad 512		#  bytes / sector
	ab 1		#  sector / cluster
	ad 1		#  sector reserved
	ab 2		#  FATs
	ad $(( 16 * 14 ))		#  root directory entries
	ad $(( 80 * 2 * 18 ))		#  sectors
	ab 0x0F0		#  media
	ad 9		#  sectors / FAT
	ad 18		#  sectors / track
	ad 2		#  heads
	aq 0		#  hidden sectors
	aq $(( 80 * 2 * 18 ))		#  sectors again
	ab 0		#  drive
		#  db 0
		#  db 29h		#  signature
		#  dd 44444444h		#  serial
		#  db ? COLOR FORTH ?		#  label
		#  db ? ?


L  command
	ab 0
	ab 0		#  head , drive
L  cylinder
	ab 0
	ab 0		#  head
	ab 1		#  sector
	ab 2		#  512 bytes / sector
	ab 18		#  sectors / track
	ab 0x1b		#  gap
	ab 0x0ff
	align 4
L  nc
	aq 9		#  Forth + Icons + blocks 24 - 161
L  gdt
	ad 0x17
	aq gdt0
	align 8
L  gdt0
	ad 0 0 0 0
	ad 0x0FFFF 0 0x9A00 0x0CF		#  code
	ad 0x0FFFF 0 0x9200 0x0CF		#  data


		#  Code is compiled in Protected 32 - bit mode.
		#  Hence org $H - 2 to fix 16 - bit words
		#  and 4 hand - assembled instructions.
		#  and EAX and AX exchanged
		#  This code is in Real 16 - bit mode


L  start0
	= 0x4F02 to A		#  Video mode
H=$H-2 
	= vesa to B		#  hp * vp rgb: 565
H=$H-2 
	submit 0x10
	IRQsoff
	zero AX
	= AX to BX
	= CS to B
	= B to DS
	= A to ES
	= AX to DI
	= AX to SI
	  call  $(( $H + 5 ))		#  Where are we? IP + 4 * CS
H=$H-2 
L  loc
	pull SI
	- $(( loc - start )) to SI
H=$H-2 
	= $(( 512 / 4 )) to C
H=$H-2 
	otheroperandsize $(( ; copies ))		#  jmp 0:relocate
	ab 0x0ea
	ad $(( relocate - start )) 0


L  relocate
		#  This code is executed from 0
	= A to DS
		#  lgdt fword ptr gdt
	ab 0x0f 1 0x16
	ad $(( gdt - start ))
	= 1 to AL
	= A to CR0
		#  jmp 8:protected
	ab 0x0ea
	ad $(( protected - start )) 8


L  protected
		#  Now in Protected 32 - bit mode
	= 0x10 to AL
	= A to DS
	= A to ES
	= A to SS
	= Gods to SP
	zero C


L  A20
	= 0x0d1 to AL
	send AL to 0x64
L  l__1
	recieve 0x64 to AL
	AND 2 to AL
	 when  not zero l__1
	= 0x4b to AL
	send AL to 0x60


	  call  dma
	upshift 4 to B
	+ B to SI
	-test 0x44444444 to @ SI		#  Boot?
	 when  not zero cold
	= $(( 63 * 0x100 - 0x80 )) to CX		#  Nope
	copies Godd to = SI
	jump start2


L  cold
	  call  sense_
	 when  not sign		 cold
	= Godd to SI
	zero DI

	= byte nc to CL
L  l__2
	push C
	  call  READ
	1+ cylinder
	pull C
	loop l__2
L  start2
	  call  stop
	jump start1


us=$((1000/  6 ))
ms=$((1000*  us ))
L  SPIN
	= 0x1c to CL
	  call  onoff
		#  mov DX , 3f2h
		#  out DX , AL
L  l__3
	  call  sense_
	 when  not sign		 l__3
	= 0 to cylinder		#  calibrate
	= 7 to AL
	= 2 to CL
	  call  cmd
	= $(( 500 * ms )) to C
L  l__4
	loop l__4
L  cmdi
	  call  sense_
	 when  sign		 cmdi
			return



L  ready
		# 	  call  delay
	= 0x3f4 to DX
L  l__5
	recieve DX to AL
	send AL to 0x0e1
	upshift 1 to AL
	 when  not carry		 l__5
	address @ D $(( + 1 )) to D
			return



L  transfer
	= 9 to CL
L  cmd
	address command to D
	= AL to @ D
L  cmd0
	push SI
	= D to SI
L  cmd1
	  call  ready
	 when  not sign		 l__6
	recieve DX to AL
	jump cmd1
	ab 0xac		#  ###fetch one byte? out DX , AL
	send AL to 0x0e1
	loop cmd1
	pull SI
		#  delay: mov EAX , us
		#  @@: dec EAX
		#  jnz @b
			return



L  sense_
	= 8 to AL
	= 1 to C
	  call  cmd

L  l__6
	  call  ready
	 when  not sign		 l__6
	recieve DX to AL
	send AL to 0x0e1
	AND AL to AL
		#  cmp AL , 80h
			return



L  seek
	  call  sense_
	 when  not sign		 seek
			return



L  stop
	= 0x0c to CL		#  Motor off
L  onoff
	DUP_
	= CL to AL
	= 0x3f2 to DX
	send AL to DX
	send AL to 0x0e1
	DROP
			return



L  dma
	otheroperandsize ; = 0x3a2 to $(( command + 1 ))		#  l2 s6 u32 ms ( e 2 )
	= 3 to AL		#  timing
	= 3 to CL
	  call  cmd
	otheroperandsize ; = 0x7000 to $(( command + 1 ))		#  + seek - fifo - poll
	= 0x13 to AL		#  configure
	= 4 to CL
	  call  cmd
	= C to command		#  0
			return



L  READ
	  call  SEEK
	= 0x0e6 to AL		#  Read normal data
	  call  TRANSFER
	= $(( 18 * 2 * 512 )) to CX
L  l__7
	  call  ready
	recieve DX to AL
	send AL to 0x0e1
	stosb
	next l__7
			return



L  WRITE
	  call  SEEK
	= 0x0c5 to AL		#  Write data
	  call  TRANSFER
	= $(( 18 * 2 * 512 )) to CX
L  l__8
	  call  ready
	lodsb
	send AL to DX
	send AL to 0x0e1
	next l__8
			return



H=0x1fe#Mark  boot sector
	ad 0x0aa55
	aq 0x44444444		#  Mark COLOR.COM


L  flop
	= AL to cylinder		#  c - cx
	DUP_
	= 0x3f2 to DX
	recieve DX to AL
	send AL to 0x0e1
	ANDtest 0x10 to AL
	 when  not zero l__9
	jump spin
L  l__9
			return



L  readf
	  call  flop		#  ac - ac
	push DI
	= @ SI $(( + 4 )) to DI
	upshift 2 to DI
	  call  READ
	pull DI
L  readf1
	DROP
	1+ A
	+ 0x1200 to @ SI
			return



L  writef
	  call  flop		#  ac - ac
	push SI
	= @ SI $(( + 4 )) to SI
	upshift 2 to SI
	  call  WRITE
	pull SI
	jump readf1



L  seekf
	  call  flop		#  c - c
		# 	  call  delay
	  call  seek
	= 0x0f to AL
	= 3 to CL
	  call  cmd
	  call  cmdi
	DROP
			return



L  cmdf
	= A to C		#  an
	DROP
	address @ A *2^ 2 to D
	  call  cmd0
	DROP
			return



L  readyf
	DUP_
	  call  ready
	DROP
			return


